#pragma warning(disable:4996)

#include "stdafx.h"
#include "Kirikiri.h"
#include "KAGScriptMgr.h"
#include "hash.hpp"

extern CKirikiriApp theApp;

int FileExists(LPCTSTR lpszName)
{
	CFileFind fileFind;
	if (!fileFind.FindFile(lpszName))
	{
		//if (DirectoryExists(lpszName)) return -1;
		return 0;
	}
	fileFind.FindNextFile();
	return fileFind.IsDirectory() ? -1 : 1;
}




CKAGScriptMgr::CKAGScriptMgr(void)
	: m_bCacheToZIP(FALSE)
	, m_bCacheToFile(FALSE)
	, m_bCacheSrc(FALSE)
	, m_pfnCallback(NULL)
	, m_pCallbackContext(NULL)
	, m_dwCurHash(0)
	, m_bLogOpened(FALSE)
{
}

CKAGScriptMgr::~CKAGScriptMgr(void)
{
	Close();
}

BOOL CKAGScriptMgr::Init()
{
	BOOL bRetVal = FALSE;
	
	Close();

	try
	{
		//   
		TCHAR wszExecPath[MAX_PATH];
		GetModuleFileName(NULL, wszExecPath, MAX_PATH);
		TCHAR* pFind = _tcsrchr(wszExecPath, _T('\\'));
		if(pFind == NULL) throw -1;
		*pFind = _T('\0');
		
		m_strGameDir = wszExecPath;

		
		// α 
		CString strLogFile = m_strGameDir + _T("\\ATLog.txt");
		if( m_fileLog.Open(strLogFile, CFile::modeReadWrite | CFile::modeCreate | CFile::modeNoTruncate) )
		{
			m_fileLog.Seek(0, CFile::end);
			m_bLogOpened = TRUE;
		}

		
		// ZIP   
		CString strATScriptFile = m_strGameDir + _T("\\ATData.zip");

		BOOL bOpened = FALSE;
		try
		{
			if( FileExists(strATScriptFile) == 1
				&& m_zip.Open(strATScriptFile, CZipArchive::zipOpen))
			{
				bRetVal = TRUE;
			}
		}
		catch(CException& ex)
		{
			// display the exception message
			ex.Delete();
		}
		catch(CException* ex)
		{
			// display the exception message
			ex->Delete();
		}
		catch(CZipException& ex	)
		{
			ex = ex;
		}
		catch(CZipException* ex	)
		{
			ex = ex;
		}

		//   
		if(FALSE == bRetVal)
		{
			m_zip.Close();
			DeleteFile(strATScriptFile);
			bRetVal = m_zip.Open(strATScriptFile, CZipArchive::zipCreate);
		}

		/*
		int nCnt = m_zip.GetCount(true);
		for(int i=0; i<nCnt; i++)
		{
			CZipString strFileName = m_zip[i]->GetFileName();
			TRACE(_T("File %d : %s"), i, strFileName.c_str());
		}
		*/

	}
	catch (int nErrCode)
	{
		nErrCode = nErrCode;
	}

	return bRetVal;
}


void CKAGScriptMgr::Close()
{
	if(m_bLogOpened)
	{
		m_fileLog.Close();
		m_bLogOpened = FALSE;
	}

	m_zip.Close();
	m_bCacheSrc = FALSE;
	m_bCacheToZIP = FALSE;
	m_bCacheToFile = FALSE;
	m_dwCurHash = 0;
	m_pfnCallback = NULL;
	m_pCallbackContext = NULL;
}


BOOL CKAGScriptMgr::GetNextLine(LPWSTR& wszBuf, CString& strLine)
{
	BOOL bRetVal = FALSE;
	
	strLine = _T("");
	
	if(wszBuf && wszBuf[0])
	{
		while(wszBuf[0])
		{
			if( L'\r' == wszBuf[0] && L'\n' == wszBuf[1] )
			{
				wszBuf += 2;
				break;
			}
			else
			{
				strLine += wszBuf[0];
			}

			wszBuf++;
		}

		bRetVal = TRUE;
	}

	return bRetVal;
}


BOOL CKAGScriptMgr::GetNextToken(LPWSTR& wszLine, CString& strToken)
{
	BOOL bRetVal = FALSE;

	strToken = _T("");

	if(wszLine && wszLine[0])
	{
		strToken += wszLine[0];
		int nTagLevel = (L'[' == wszLine[0] ? 1 : 0);
		wszLine++;
		
		// '[' ± 
		if(nTagLevel)
		{
			while(*wszLine && nTagLevel > 0)
			{

				if( L'[' == *wszLine )
				{
					nTagLevel++;
				}
				else if(L']' == *wszLine)
				{
					nTagLevel--;
				}

				strToken += *wszLine;
				wszLine++;
			}

		}
		// Ϲ ū̸
		else
		{
			while(*wszLine && L'[' != *wszLine)
			{
				if(L']' == wszLine[0])
				{
					strToken += wszLine[0];
					wszLine++;
					break;
				}

				strToken += wszLine[0];
				wszLine++;
			}
		}
		


		bRetVal = TRUE;
	}

	return bRetVal;	
}


//////////////////////////////////////////////////////////////////////////
//
// <ܺο ȣǴ   Լ>
//
//////////////////////////////////////////////////////////////////////////
BOOL CKAGScriptMgr::TranslateScript(LPCWSTR cwszSrc, LPWSTR wszTar)
{
	if(NULL == cwszSrc || NULL == wszTar || L'\0' == cwszSrc[0]) return FALSE;
	
	BOOL bRetVal = FALSE;

	//  ؽƮ ؽø Ѵ.
	m_dwCurHash = MakeStringHash(cwszSrc);

	//  ĳ ɼ  Ѵ.
	if(m_bCacheSrc)
	{
		// ϸ 
		CString strJpnFileName;
		strJpnFileName.Format(_T("Script\\JPN\\JPN_%p.txt"), m_dwCurHash);
		WriteLog(strJpnFileName + _T(" <-- Loaded..."));

		// zip Ͽ 
		if(m_bCacheToZIP) SaveToZip(strJpnFileName, cwszSrc);

		// Ϸε 
		if(m_bCacheToFile) SaveToFile(strJpnFileName, cwszSrc);
	}
	
	// ҿ ĳ̵ ͸ ã´
	CString strKorFileName;
	strKorFileName.Format(_T("Script\\KOR\\KOR_%p.txt"), m_dwCurHash);
	

	// Zip ĳ̵ Ͱ 
	if(m_bCacheToZIP && LoadFromZip(strKorFileName, wszTar))
	{
		TRACE(_T("[aral1] LoadFromZip('%s') OK "), (LPCTSTR)strKorFileName);
		WriteLog(strKorFileName + _T(" <-- Loaded from ZIP"));
		bRetVal = TRUE;
	}
	// Ϸ ĳ̵ Ͱ 
	else if(m_bCacheToFile && LoadFromFile(strKorFileName, wszTar))
	{
		TRACE(_T("[aral1] LoadFromFile('%s') OK "), (LPCTSTR)strKorFileName);
		WriteLog(strKorFileName + _T(" <-- Loaded from FILE"));
		bRetVal = TRUE;
		
	}
	// ĳ̵ Ͱ 
	else
	{
		bRetVal = TranslateUsingTranslator(cwszSrc, wszTar);
		TRACE(_T("[aral1] TranslateUsingTranslator() result : %d"), bRetVal);

		if(bRetVal)
		{
			if(m_bCacheToZIP)
			{
				BOOL bSave = SaveToZip(strKorFileName, wszTar);
				TRACE(_T("[aral1] SaveToZip('%s') result : %d"), (LPCTSTR)strKorFileName, bSave);
				WriteLog(strKorFileName + _T(" <-- Translated and Saved to ZIP"));
			}

			if(m_bCacheToFile)
			{
				BOOL bSave = SaveToFile(strKorFileName, wszTar);
				TRACE(_T("[aral1] SaveToFile('%s') result : %d"), (LPCTSTR)strKorFileName, bSave);
				WriteLog(strKorFileName + _T(" <-- Translated and Saved to File"));
			}

		}
	}


	//TRACE(_T("[aral1] TranslateScript() end"));
	return bRetVal;
}


//////////////////////////////////////////////////////////////////////////
//
// ⸦ Ͽ ũƮ ü Ѵ.
//
//////////////////////////////////////////////////////////////////////////
BOOL CKAGScriptMgr::SaveToZip(LPCTSTR strFileName, LPCWSTR cwszScript)
{
	BOOL bRetVal = FALSE;

	if(strFileName && cwszScript)
	{		
		// Ϸ   
		size_t len = wcslen(cwszScript);
		wchar_t* buf = new wchar_t[len + 1];
		buf[0] = 0xFEFF;
		memcpy(&buf[1], cwszScript, len*sizeof(wchar_t));

		//  ZIP  
		ZIP_INDEX_TYPE zip_idx = m_zip.FindFile(strFileName, CZipArchive::ffNoCaseSens);
		if( ZIP_FILE_INDEX_NOT_FOUND != zip_idx )
		{
			m_zip.RemoveFile(zip_idx);
		}

		// ZIP Ͽ ߰
		CZipFileHeader templ;
		templ.SetFileName(strFileName);
		m_zip.SetFileHeaderAttr(templ, 0);
		
		// ī̺꿡  ڵ带 Ѵ.
		if( m_zip.OpenNewFile(templ, CZipCompressor::levelFastest) )
		{
			//   
			if( m_zip.WriteNewFile(buf, (len+1)*sizeof(wchar_t)) )
			{
				bRetVal = TRUE;
			}

			//  ڵ ݱ
			m_zip.CloseNewFile();

		}
		
		// ۹ 
		delete [] buf;
	}

	return bRetVal;
}


//////////////////////////////////////////////////////////////////////////
//
// ⸦ Ͽ ũƮ ü Ѵ.
//
//////////////////////////////////////////////////////////////////////////
BOOL CKAGScriptMgr::LoadFromZip(LPCTSTR strFileName, LPWSTR wszScript)
{
	BOOL bRetVal = FALSE;

	if(strFileName && wszScript)
	{
		
		ZIP_INDEX_TYPE idx = m_zip.FindFile(strFileName, CZipArchive::ffNoCaseSens);

		//  ε ZIP   
		if( ZIP_FILE_INDEX_NOT_FOUND != idx && m_zip.OpenFile(idx) )
		{
			//  ũ ϱ
			DWORD uSize = (DWORD)m_zip[idx]->m_uUncomprSize;

			int buf_len = (uSize >> 1) + 2;
			wchar_t* buf = new wchar_t[buf_len];

			//  
			char temp;
			if (m_zip.ReadFile(buf, uSize) == uSize && m_zip.ReadFile(&temp, 1) == 0)
			{
				buf[(uSize >> 1)] = L'\0';
				int nStartIdx = 0;
				if(0xFEFF == buf[0]) nStartIdx = 1;
				wcscpy(wszScript, &buf[nStartIdx]);

				bRetVal = TRUE;
			}


			// ۹ 
			delete [] buf;

			//  ݱ			
			m_zip.CloseFile();

			// ж  
			if(FALSE == bRetVal) m_zip.RemoveFile(idx);

		}
	}

	return bRetVal;
}


//////////////////////////////////////////////////////////////////////////
//
// ⸦ Ͽ ũƮ ü Ѵ.
//
//////////////////////////////////////////////////////////////////////////
BOOL CKAGScriptMgr::SaveToFile(LPCTSTR strFileName, LPCWSTR cwszScript)
{
	BOOL bRetVal = FALSE;

	if(strFileName && cwszScript)
	{		
		// Ϸ   
		size_t len = wcslen(cwszScript);
		wchar_t* buf = new wchar_t[len + 1];
		buf[0] = 0xFEFF;
		memcpy(&buf[1], cwszScript, len*sizeof(wchar_t));

		// 丮  (ӽڵ)
		CreateDirectory(m_strGameDir + _T("\\ATData"), NULL);
		CreateDirectory(m_strGameDir + _T("\\ATData\\Script"), NULL);
		CreateDirectory(m_strGameDir + _T("\\ATData\\Script\\KOR"), NULL);
		CreateDirectory(m_strGameDir + _T("\\ATData\\Script\\JPN"), NULL);

		// ̸ 
		CString strFullPath = m_strGameDir + _T("\\ATData\\") + strFileName;

		//  
		CFile f;
		if( f.Open(strFullPath, CFile::modeCreate | CFile::modeWrite) )
		{
			f.Write(buf, (len+1)*sizeof(wchar_t));
			f.Close();
			
			bRetVal = TRUE;
		}

		// ۹ 
		delete [] buf;
	}

	return bRetVal;
}


//////////////////////////////////////////////////////////////////////////
//
// ⸦ Ͽ ũƮ ü Ѵ.
//
//////////////////////////////////////////////////////////////////////////
BOOL CKAGScriptMgr::LoadFromFile(LPCTSTR strFileName, LPWSTR wszScript)
{
	BOOL bRetVal = FALSE;

	if(strFileName && wszScript)
	{
		// ̸ 
		CString strFullPath = m_strGameDir + _T("\\ATData\\") + strFileName;

		//  
		CFile f;
		if( f.Open(strFullPath, CFile::modeRead) )
		{
			UINT nLen = (UINT)f.GetLength();
			
			wchar_t* buf = new wchar_t[(nLen>>1) + 1];

			if( f.Read(buf, nLen) == nLen )
			{
				buf[(nLen>>1)] = L'\0';

				int nStartIdx = 0;
				if(	buf[0] == 0xFEFF ) nStartIdx = 1;
				wcscpy(wszScript, &buf[nStartIdx]);

				bRetVal = TRUE;

			}

			f.Close();

			// ۹ 
			delete [] buf;
		}

	}

	return bRetVal;
}



void DeletePath(CString strPath)
{
	CFileFind finder;
	BOOL bContinue = TRUE;

	if(strPath.Right(1) != _T("\\"))
		strPath += _T("\\");

	strPath += _T("*.*");
	bContinue = finder.FindFile(strPath);
	while(bContinue)
	{
		bContinue = finder.FindNextFile();
		if(finder.IsDots()) // Ignore this item.
		{
			continue;
		}
		else if(finder.IsDirectory()) // Delete all sub item.
		{
			DeletePath(finder.GetFilePath());
			::RemoveDirectory((LPCTSTR)finder.GetFilePath());
		}
		else // Delete file.
		{
			::DeleteFile((LPCTSTR)finder.GetFilePath());
		}
	}


	finder.Close();


	strPath = strPath.Left(strPath.ReverseFind('\\'));   // "c:\\a\\"  -->  "c:\\a" ̿Ȱ
	::RemoveDirectory((LPCTSTR)strPath);


}



//////////////////////////////////////////////////////////////////////////
//
// ĳ ʱȭ
//
//////////////////////////////////////////////////////////////////////////
BOOL CKAGScriptMgr::ClearCache()
{
	BOOL bRetVal = FALSE;

	//  
	DeletePath(m_strGameDir + _T("\\ATData"));

	// ZIP 
	CString strATScriptFile = m_strGameDir + _T("\\ATData.zip");
	m_zip.Close();
	DeleteFile(strATScriptFile);

	// ZIP   
	bRetVal = m_zip.Open(strATScriptFile, CZipArchive::zipCreate);

	return bRetVal;
}



//////////////////////////////////////////////////////////////////////////
//
// ⸦ Ͽ ũƮ ü Ѵ.
// ( ߷ ڵ;; ӳ ̰.. )
//
//////////////////////////////////////////////////////////////////////////
BOOL CKAGScriptMgr::TranslateUsingTranslator(LPCWSTR cwszSrc, LPWSTR wszTar)
{
	BOOL bRetVal = FALSE;

	LPWSTR wszSrc = (LPWSTR)cwszSrc;
	int nTotalLines = GetTotalLines(cwszSrc);
	int nCurLine = 0;
	
	// ݹԼ  
	if(m_pfnCallback)
	{
		m_pfnCallback(m_pCallbackContext, 0, nTotalLines);
	}

	CString strLine = L"";
	CString strSkipTillThisString = L"";
	
	try
	{
		while( GetNextLine(wszSrc, strLine) )
		{
			//log.Write( (LPCWSTR)(_T("[IN ] ") + strLine + _T("\r\n")), (strLine.GetLength() + 8)*2 );

			CString strFilterLine = strLine;
			strFilterLine.Remove(_T('\t'));

			// ŵ  
			if(!strSkipTillThisString.IsEmpty())
			{
				strLine = TranslateOnlyTextToken(strLine);
				size_t len = wcslen((LPCWSTR)strLine);
				memcpy(wszTar, (LPCWSTR)strLine, len*sizeof(wchar_t));
				wszTar += len;

				if(strLine.Find(strSkipTillThisString) >= 0) strSkipTillThisString = L"";
			}
			// Ϲ  
			else if(L';' == strFilterLine[0] || L'@' == strFilterLine[0] || L'*' == strFilterLine[0])
			{
				if(L'@' == strFilterLine[0]) strLine = TranslateOnlyTextToken(strLine);
				size_t len = wcslen((LPCWSTR)strLine);
				memcpy(wszTar, (LPCWSTR)strLine, len*sizeof(wchar_t));
				wszTar += len;

				if(strFilterLine.Find(L"@iscript") >= 0 ) strSkipTillThisString = L"@endscript";
			}
			// ūȭ ʿ ̶
			else if (!strLine.IsEmpty())
			{
				CString strToken = L"";
				LPWSTR wszLine = (LPWSTR)(LPCWSTR)strLine;
				while ( GetNextToken(wszLine, strToken) )
				{
					int nDotIdx = GetHelperTextCommaIdx(strToken);

					// Ϲ  ū̶
					if( strToken == L"\t" || (strToken[0] == L'[' && nDotIdx < 0) )
					{
						if(L'[' == strToken[0])
						{
							// case "[:...]"
							if(L':' == strToken[1])
							{
								CString strTextPart = strToken.Mid(2, strToken.GetLength()-3);
								wchar_t wszTransTextPart[256];
								if(TranslateUnicodeText(strTextPart, wszTransTextPart))
								{
									strToken.Format(L"[:%s]", wszTransTextPart);
								}
							}
							else
							{
								strToken = TranslateOnlyTextToken(strToken);
							}
						}
						size_t len = wcslen((LPCWSTR)strToken);
						memcpy(wszTar, (LPCWSTR)strToken, len*sizeof(wchar_t));
						wszTar += len;

						if(strToken == L"[iscript]")
						{
							len = wcslen(wszLine);
							memcpy(wszTar, wszLine, len*sizeof(wchar_t));
							wszTar += len;

							if(strLine.Find(L"[endscript]") < 0) strSkipTillThisString = L"[endscript]";
							break;
						}
					}

					// ؽƮ̰ų  ÷̸
					else
					{
						CString strTextJpn = _T("");

						while(!strToken.IsEmpty())
						{

							if(nDotIdx > 0)
							{
								strTextJpn += strToken.Mid(1, nDotIdx-1);
								//strHelperText = strToken.Mid(nDotIdx+1, len-nDotIdx-2);								
							}
							else
							{
								strTextJpn += strToken;
							}

							strToken = _T("");

							LPWSTR tmpLine = wszLine;

							// Ƿ Ѱ ū   ؼؾ Ѵٸ
							if( GetNextToken(tmpLine, strToken) && !strToken.IsEmpty() )
							{
								nDotIdx = GetHelperTextCommaIdx(strToken);

								// ÷ ڿ ƴϰ Ϲ ؽƮ ƴϸ 
								if(nDotIdx < 0 && L'[' == strToken[0]) 
								{
									strToken = _T("");
									break;
								}

								wszLine = tmpLine;
							}

						}

						// 
						wchar_t tmpKorText[1024];
						ZeroMemory(tmpKorText, 1024*sizeof(wchar_t));
						TranslateUnicodeText(strTextJpn, tmpKorText);

						// ̸ 
						int nJpnLen = strTextJpn.GetLength();
						if( nJpnLen > 2
							&& 0x3010 == strTextJpn[0]
							&& 0x3011 == strTextJpn[nJpnLen-1] )
						{
							CString strTextKor = tmpKorText;
							int nJpnSlash = strTextJpn.Find(_T('/'));
							int nKorSlash = strTextKor.Find(_T('/'));
							
							// ð ̹ Ե 
							if(nJpnSlash > 0 && nKorSlash > 0)
							{
								strTextKor = strTextJpn.Left(nJpnSlash) + strTextKor.Mid(nKorSlash);
							}
							// ð  ̸ 籸Ѵ.
							else
							{
								strTextKor = strTextJpn.Left(nJpnLen-1) + L"/" + strTextKor.Mid(1);								
							}

							size_t len = strTextKor.GetLength();
							memcpy(wszTar, (LPCWSTR)strTextKor, len*sizeof(wchar_t));
							wszTar += len;
						}
						else
						{
							size_t len = wcslen(tmpKorText);
							memcpy(wszTar, (LPCWSTR)tmpKorText, len*sizeof(wchar_t));
							wszTar += len;
						}

					}

				}// end of while (Token)

			}// end of else

			*wszTar = L'\r'; wszTar++;
			*wszTar = L'\n'; wszTar++;
			*wszTar = L'\0';

			nCurLine++;

			// ݹ  Ȳ 
			if(m_pfnCallback)
			{
				int nContinue = m_pfnCallback(m_pCallbackContext, nCurLine, nTotalLines);
				if(0 == nContinue) throw -1;
			}
		}// end of while (Line)

		bRetVal = TRUE;

	}
	catch (int nErrCode)
	{
		nErrCode = nErrCode;
		bRetVal = FALSE;
	}


	return bRetVal;
}

CString CKAGScriptMgr::TranslateOnlyTextToken( LPCWSTR cwszLine )
{
	CString strRetVal = _T("");
	CString strTextToken = _T("");

	int i = 0;
	//BOOL bTextMode = FALSE;
	wchar_t chTextMode = L'\0';
	while(cwszLine[i])
	{
		// ǥ ٸ
		if( ( L'\0' == chTextMode && (L'\"' == cwszLine[i] || L'\'' == cwszLine[i]) )
			|| ( L'\0' != chTextMode && chTextMode == cwszLine[i]  ) )
		{
			// ؽƮ   ٸ
			if(chTextMode)
			{
				int nStrLen = strTextToken.GetLength();
				wchar_t tmpBuf[1024];
				// "txt=", "text="
				if( i > nStrLen+9 
					&& ( 
						wcsncmp(L" txt=", &cwszLine[i-5-1-nStrLen], 5) == 0 
						|| wcsncmp(L" txt = ", &cwszLine[i-7-1-nStrLen], 7) == 0 
						|| wcsncmp(L" text=", &cwszLine[i-6-1-nStrLen], 6) == 0 
						|| wcsncmp(L" text = ", &cwszLine[i-8-1-nStrLen], 8) == 0 
					)
					&& TranslateUnicodeText(strTextToken, tmpBuf) )
				{
					strRetVal += tmpBuf;
				}
				else
				{
					strRetVal += strTextToken;
				}

				//  ʱȭ
				chTextMode = '\0';
				strTextToken = _T("");
			}
			// Ϲ  ٸ
			else
			{
				chTextMode = cwszLine[i];
			}

			strRetVal += cwszLine[i];
			
		}
		// ǥ ƴϸ
		else
		{
			if(chTextMode) strTextToken += cwszLine[i];
			else strRetVal += cwszLine[i];

		}

		// ε 
		i++;
	}

	//  ִ ؽƮ ū ִٸ ٿش.
	if(chTextMode)
	{
		//strRetVal += L'\"';
		strRetVal += strTextToken;
	}

	return strRetVal;
}

//////////////////////////////////////////////////////////////////////////
//
// ⸦ Ͽ Ϻ  Ѵ.
//
//////////////////////////////////////////////////////////////////////////
BOOL CKAGScriptMgr::TranslateUnicodeText( LPCWSTR cwszSrc, LPWSTR wszTar )
{
	BOOL bRetVal = FALSE;

	if(NULL == cwszSrc || NULL == wszTar || wcslen(cwszSrc) > 1024) return FALSE;
	
	char tmpJpn[2048];
	char tmpKor[2048];
	ZeroMemory(tmpJpn, 2048);
	ZeroMemory(tmpKor, 2048);

	MyWideCharToMultiByte(932, 0, cwszSrc, -1, tmpJpn, 2048, NULL, NULL);

	if(theApp.m_sContainerFunc.pfnTranslateText)
	{
		bRetVal = theApp.m_sContainerFunc.pfnTranslateText(tmpJpn, tmpKor, 2048);

		if(TRUE == bRetVal)
		{
			MyMultiByteToWideChar(949, 0, tmpKor, -1, wszTar, 1024);
		}
	}

	return bRetVal;
}

int CKAGScriptMgr::GetHelperTextCommaIdx( LPCWSTR cwszToken )
{
	int nDotIdx = -1;
	
	if(cwszToken && cwszToken[0] == L'[')
	{
		size_t len = wcslen(cwszToken);

		// ÷ ˻
		for(int k=1; k<(int)len-1; k++)
		{
			if(L',' == cwszToken[k])
			{
				if(nDotIdx > 0)
				{
					nDotIdx = -1;
					break;
				}
				else
				{
					nDotIdx = k;
				}
			}
			else if(cwszToken[k] < (wchar_t)0x80)
			{
				nDotIdx = -1;
				break;									
			}
		}

	}
	
	return nDotIdx;

}

void  CKAGScriptMgr::SetProgressCallback(void* pContext, PROC_TransProgress pfnCallback)
{
	m_pCallbackContext = pContext;
	m_pfnCallback = pfnCallback;
}

int CKAGScriptMgr::GetTotalLines( LPCWSTR cwszText )
{
	int nRetVal = 0;
	
	if(cwszText && cwszText[0])
	{
		nRetVal = 1;

		while(cwszText[0])
		{
			if( L'\r' == cwszText[0] && L'\n' == cwszText[1] )
			{
				nRetVal++;
			}

			cwszText++;
		}
	}

	return nRetVal;
}

UINT CKAGScriptMgr::GetCurrentScriptHash()
{
	
	return m_dwCurHash;
}



void CKAGScriptMgr::WriteLog( LPCTSTR cszLine )
{
	CTime t = CTime::GetCurrentTime();
	m_fileLog.WriteString(t.Format(_T("[%Y-%m-%d %H:%M:%S] ")) );
	m_fileLog.WriteString(cszLine);
	m_fileLog.WriteString(_T("\r\n"));
}